// ObjSysParamsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "..//Solidgraph.h"
#include "ObjSysParamsDlg.h"

// CObjSysParamsDlg dialog

IMPLEMENT_DYNCREATE(CObjSysParamsDlg, CDialog)

CObjSysParamsDlg::CObjSysParamsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CObjSysParamsDlg::IDD, pParent)
	, m_editing_object(NULL)
{
	m_otiEdit = NULL;
	m_otiLayerCombo = NULL;
	m_otiColorCombo = NULL;
	m_otiThicknessCombo = NULL;
	m_otiTypeCombo = NULL;
	m_otiFrameOrSolidVis_radio = NULL;
	m_otiVis_check = NULL;
	m_otiGabVis_check = NULL;
}

CObjSysParamsDlg::~CObjSysParamsDlg()
{
}

void CObjSysParamsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BOOL CObjSysParamsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	if (!m_editing_object)
	{
		ASSERT(0);
		return FALSE;
	}
	
	COptionTreeItem *otiRoot = NULL;
	COptionTreeItem *otiItem = NULL;
	COptionTreeItemStatic *otiStatic = NULL;
	/*COptionTreeItemCheckBox *otiCheck = NULL;
	COptionTreeItemRadio *otiRadio = NULL;
	COptionTreeItemSpinner *otiSpinner = NULL;
	COptionTreeItemColor *otiColor = NULL;
	COptionTreeItemHyperLink *oti_Hyperlink = NULL;*/
	CRect rcClient;
	DWORD dwStyle, dwOptions;
	LOGFONT lfFont, lfDefaultFont;

	// Get log fonts
	GetFont()->GetLogFont(&lfFont);
	GetFont()->GetLogFont(&lfDefaultFont);
	strcpy(lfDefaultFont.lfFaceName, _T("Arial"));

	// Get the clients rectangle
	GetClientRect(rcClient);

	// Setup the window style
	dwStyle = WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN;

	// Setup the tree options 
	// OT_OPTIONS_SHOWINFOWINDOW
	dwOptions = OT_OPTIONS_SHADEEXPANDCOLUMN | OT_OPTIONS_SHADEROOTITEMS | OT_OPTIONS_SHOWINFOWINDOW;

	int  trBot=rcClient.bottom;
	if (GetDlgItem(IDOK))
	{
		CRect rrrr;
		GetDlgItem(IDOK)->GetWindowRect(rrrr);
		ScreenToClient(rrrr);
		trBot = rrrr.top -4;
	}
	// Create tree options
	CRect trR = rcClient;
	trR.bottom = trBot;
	if (m_otTree.Create(dwStyle, trR, this, dwOptions, 1004) == FALSE)
	{
		TRACE0("Failed to create options control.\r\n");
		return FALSE;
	}

	// Want to be notified
	m_otTree.SetNotify(TRUE, this);

	CString resStr;
	otiRoot = m_otTree.InsertItem(new COptionTreeItem());
	resStr.LoadString(IDS_OB_PR_DL_ATTRIBUTES);
	otiRoot->SetLabelText(resStr);
	resStr.LoadString(IDS_OB_PR_DL_FULL_ATTRIBUTES);
	otiRoot->SetInfoText(resStr);
	// -- Edit Items -> Edit Item
	m_otiEdit = (COptionTreeItemEdit*)m_otTree.InsertItem(new COptionTreeItemEdit(), otiRoot);
	resStr.LoadString(IDS_OB_PR_DL_NAME);
	m_otiEdit->SetLabelText(resStr);
	resStr.LoadString(IDS_OB_PR_DL_FULL_NAME);
	m_otiEdit->SetInfoText(resStr);
	if (m_otiEdit->CreateEditItem(NULL, NULL) == TRUE)
	{
		m_otiEdit->SetWindowText(m_editing_object->GetName());	
	}

	m_otiLayerCombo = (COptionTreeItemComboBox*)m_otTree.InsertItem(new COptionTreeItemComboBox(), otiRoot);
	resStr.LoadString(IDS_OB_PR_DL_LAYER);
	m_otiLayerCombo->SetLabelText(resStr);
	resStr.LoadString(IDS_OB_PR_DL_FULL_LAYER);
	m_otiLayerCombo->SetInfoText(resStr);
	resStr.LoadString(IDS_OB_PR_DL_LAYER);
	if (m_otiLayerCombo->CreateComboItem(NULL) == TRUE)
	{
		CString  labl;
		labl.LoadString(IDS_LAYER_LABEL);
		CString  curLbl;
		unsigned char lCnt = 1;//sgGetScene()->GetLayersCount();
		for (unsigned char i=0;i<lCnt;i++)
		{
			curLbl.Format(" %i",i);
			m_otiLayerCombo->AddString(labl+curLbl);
		}
		m_otiLayerCombo->SelectString(m_editing_object->GetAttribute(SG_OA_LAYER), resStr);
	}
	
	m_otiColorCombo = (COptionTreeItemColorComboBox*)m_otTree.InsertItem(new COptionTreeItemColorComboBox(), otiRoot);
	resStr.LoadString(IDS_OB_PR_DL_COLOR);
	m_otiColorCombo->SetLabelText(resStr);
	resStr.LoadString(IDS_OB_PR_DL_FULL_COLOR);
	m_otiColorCombo->SetInfoText(resStr);
	if (m_otiColorCombo->CreateComboItem(NULL) == TRUE)
	{
		m_otiColorCombo->SetCurColor(m_editing_object->GetAttribute(SG_OA_COLOR));	
	}
	m_otiThicknessCombo = (COptionTreeItemLineThikComboBox*)m_otTree.InsertItem(new COptionTreeItemLineThikComboBox(), otiRoot);
	resStr.LoadString(IDS_OB_PR_DL_LIN_TH);
	m_otiThicknessCombo->SetLabelText(resStr);
	resStr.LoadString(IDS_OB_PR_DL_FULL_LIN_TH);
	m_otiThicknessCombo->SetInfoText(resStr);
	if (m_otiThicknessCombo->CreateComboItem(NULL) == TRUE)
	{
		m_otiThicknessCombo->SetLineThickness(m_editing_object->GetAttribute(SG_OA_LINE_THICKNESS));
	}
	m_otiTypeCombo = (COptionTreeItemLineTypeComboBox*)m_otTree.InsertItem(new COptionTreeItemLineTypeComboBox(), otiRoot);
	resStr.LoadString(IDS_OB_PR_DL_LN_TY);
	m_otiTypeCombo->SetLabelText(resStr);
	resStr.LoadString(IDS_OB_PR_DL_FULL_LN_TY);
	m_otiTypeCombo->SetInfoText(resStr);
	if (m_otiTypeCombo->CreateComboItem(NULL) == TRUE)
	{
		m_otiTypeCombo->SetLineType(m_editing_object->GetAttribute(SG_OA_LINE_TYPE));
	}

	otiRoot->Expand();


	otiRoot = m_otTree.InsertItem(new COptionTreeItem());
	resStr.LoadString(IDS_OB_PR_DL_VIS);
	otiRoot->SetLabelText(resStr);
	resStr.LoadString(IDS_OB_PR_DL_FULL_VIS);
	otiRoot->SetInfoText(resStr);

	m_otiVis_check = (COptionTreeItemCheckBox*)m_otTree.InsertItem(new COptionTreeItemCheckBox(), otiRoot);
	resStr.LoadString(IDS_OB_PR_DL_SHOW);
	m_otiVis_check->SetLabelText(resStr);
	resStr.LoadString(IDS_OB_PR_DL_FULL_SHOW);
	m_otiVis_check->SetInfoText(resStr);
	short ds = m_editing_object->GetAttribute(SG_OA_DRAW_STATE);
	if (m_otiVis_check->CreateCheckBoxItem((ds & SG_DS_HIDE)==0, 
		OT_CHECKBOX_SHOWCHECK) == TRUE)
	{
		CString yesS;
		yesS.LoadString(IDS_OB_PR_DL_SHOW_YES);
		CString noS;
		noS.LoadString(IDS_OB_PR_DL_SHOW_NO);
		m_otiVis_check->SetCheckText(yesS, noS);
	}

	m_otiGabVis_check = (COptionTreeItemCheckBox*)m_otTree.InsertItem(new COptionTreeItemCheckBox(), otiRoot);
	resStr.LoadString(IDS_OB_PR_DL_GAB);
	m_otiGabVis_check->SetLabelText(resStr);
	resStr.LoadString(IDS_OB_PR_DL_FULL_GAB);
	m_otiGabVis_check->SetInfoText(resStr);
	if (m_otiGabVis_check->CreateCheckBoxItem((ds & SG_DS_GABARITE)!=0, 
		OT_CHECKBOX_SHOWCHECK) == TRUE)
	{
		CString yesS;
		yesS.LoadString(IDS_OB_PR_DL_GAB_YES);
		CString noS;
		noS.LoadString(IDS_OB_PR_DL_GAB_NO);
		m_otiGabVis_check->SetCheckText(yesS, noS);
	}

	if (m_editing_object->GetType()==SG_OT_3D)
	{

		m_otiFrameOrSolidVis_radio = (COptionTreeItemRadio*)m_otTree.InsertItem(new COptionTreeItemRadio(), otiRoot);
		resStr.LoadString(IDS_OB_PR_DL_DRAW);
		m_otiFrameOrSolidVis_radio->SetLabelText(resStr);
		resStr.LoadString(IDS_OB_PR_DL_FULL_DRAW);
		m_otiFrameOrSolidVis_radio->SetInfoText(resStr);
		if (m_otiFrameOrSolidVis_radio->CreateRadioItem() == TRUE)
		{
			resStr.LoadString(IDS_OB_PR_DL_DRAW_FR);
			m_otiFrameOrSolidVis_radio->InsertNewRadio(resStr, (ds & SG_DS_FRAME)!=0);
			resStr.LoadString(IDS_OB_PR_DL_DRAW_SOL);
			m_otiFrameOrSolidVis_radio->InsertNewRadio(resStr, (ds & SG_DS_FULL)!=0);
		}

	}

	otiRoot->Expand();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

BEGIN_MESSAGE_MAP(CObjSysParamsDlg, CDialog)
	ON_WM_SIZE()
END_MESSAGE_MAP()


void CObjSysParamsDlg::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	if (GetDlgItem(IDOK))
	{
		CRect rrr;
		GetDlgItem(IDOK)->GetWindowRect(rrr);
		ScreenToClient(rrr);

		m_otTree.MoveWindow(0,0,cx,cy-rrr.top-4);
	}
}

void CObjSysParamsDlg::OnOK()
{
	if (m_otiEdit->IsSelected())
		m_otiEdit->CommitChanges();
	if (m_otiLayerCombo->IsSelected())
		m_otiLayerCombo->CommitChanges();
	if (m_otiColorCombo->IsSelected())
		m_otiColorCombo->CommitChanges();
	if (m_otiThicknessCombo->IsSelected())
		m_otiThicknessCombo->CommitChanges();
	if (m_otiTypeCombo->IsSelected())
		m_otiTypeCombo->CommitChanges();

	if (m_otiFrameOrSolidVis_radio && m_otiFrameOrSolidVis_radio->IsSelected())
		m_otiFrameOrSolidVis_radio->CommitChanges();
	if (m_otiVis_check->IsSelected())
		m_otiVis_check->CommitChanges();
	if (m_otiGabVis_check->IsSelected())
		m_otiGabVis_check->CommitChanges();
	
	CString      nm;
	m_otiEdit->GetWindowText(nm);
	unsigned int col = m_otiColorCombo->GetCurColor();
	unsigned int thik = m_otiThicknessCombo->GetLineThickness();
	unsigned int typ = m_otiTypeCombo->GetLineType();

	if (m_editing_object)
	{
		m_editing_object->SetName(nm);
		m_editing_object->SetAttribute(SG_OA_LAYER,m_otiLayerCombo->GetCurSel());
		m_editing_object->SetAttribute(SG_OA_COLOR,col);
		m_editing_object->SetAttribute(SG_OA_LINE_THICKNESS,thik);
		m_editing_object->SetAttribute(SG_OA_LINE_TYPE, typ);

		if (m_otiFrameOrSolidVis_radio)
		{
			int chNode = m_otiFrameOrSolidVis_radio->Node_GetChecked();
			if (chNode==-1)
			{
				ASSERT(0);
			}
			if (chNode==0)
			{
				m_editing_object->SetAttribute(SG_OA_DRAW_STATE,m_editing_object->GetAttribute(SG_OA_DRAW_STATE)|SG_DS_FRAME);
				m_editing_object->SetAttribute(SG_OA_DRAW_STATE,m_editing_object->GetAttribute(SG_OA_DRAW_STATE)& ~SG_DS_FULL);
			}
			else
			{
				m_editing_object->SetAttribute(SG_OA_DRAW_STATE,m_editing_object->GetAttribute(SG_OA_DRAW_STATE)|SG_DS_FULL);
				m_editing_object->SetAttribute(SG_OA_DRAW_STATE,m_editing_object->GetAttribute(SG_OA_DRAW_STATE)& ~SG_DS_FRAME);
			}
		}

		if (m_otiVis_check->GetCheck())
			m_editing_object->SetAttribute(SG_OA_DRAW_STATE,m_editing_object->GetAttribute(SG_OA_DRAW_STATE)& ~SG_DS_HIDE);
		else
			m_editing_object->SetAttribute(SG_OA_DRAW_STATE,m_editing_object->GetAttribute(SG_OA_DRAW_STATE)|SG_DS_HIDE);

		if (m_otiGabVis_check->GetCheck())
			m_editing_object->SetAttribute(SG_OA_DRAW_STATE,m_editing_object->GetAttribute(SG_OA_DRAW_STATE)|SG_DS_GABARITE);
		else
			m_editing_object->SetAttribute(SG_OA_DRAW_STATE,m_editing_object->GetAttribute(SG_OA_DRAW_STATE)& ~SG_DS_GABARITE);
	}

	CDialog::OnOK();
}
