// SolidgraphDoc.cpp : implementation of the CSolidgraphDoc class
//

#include "stdafx.h"
#include "Solidgraph.h"

#include "SolidgraphDoc.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSolidgraphDoc

IMPLEMENT_DYNCREATE(CSolidgraphDoc, CDocument)

BEGIN_MESSAGE_MAP(CSolidgraphDoc, CDocument)
  ON_COMMAND(ID_DXF_EXPORT, OnDxfExport)
  ON_COMMAND(ID_DXF_IMPORT, OnDxfImport)
  ON_COMMAND(ID_STL_EXPORT, OnSTLExport)
  ON_COMMAND(ID_STL_IMPORT, OnSTLImport)
END_MESSAGE_MAP()

CSolidgraphDoc*  global_3D_document=NULL;

// CSolidgraphDoc construction/destruction

CSolidgraphDoc::CSolidgraphDoc()
{
	global_3D_document = this;
}

CSolidgraphDoc::~CSolidgraphDoc()
{
	global_3D_document = NULL;
}

BOOL CSolidgraphDoc::IsModified()
{
  return (!sgGetScene()->IsUndoStackEmpty());
}

void CSolidgraphDoc::SetSceneSetups(const SCENE_SETUPS&  scS)
{
	if (scS.CurrentColor>239)
		m_scene_setups.CurrentColor = 239;
	else
		m_scene_setups.CurrentColor = scS.CurrentColor;

	m_scene_setups.CurrentLineThickness = scS.CurrentLineThickness;
	m_scene_setups.CurrentLineType = scS.CurrentLineType;
	m_scene_setups.CurrentLayer = scS.CurrentLayer;

	if (scS.CurrentPrecision>=PREC_COUNT)
		m_scene_setups.CurrentPrecision = PREC_COUNT-1;
	else
		m_scene_setups.CurrentPrecision = scS.CurrentPrecision;
}

void CSolidgraphDoc::GetSceneSetups(SCENE_SETUPS& scS)
{
	memcpy(&scS, &m_scene_setups, sizeof(SCENE_SETUPS));
}
/*
class AAA:public SG_USER_DYNAMIC_DATA
{
	int* m_aaa;
public:
	AAA() {m_aaa=new int[10];}
	~AAA() {delete[] m_aaa;};
	virtual void Finalize()
	{
		if (m_aaa)
		{
			delete[] m_aaa;
			m_aaa = NULL;
			delete this;
		}
	}
};
*/

BOOL CSolidgraphDoc::OnNewDocument()
{
  if (!CDocument::OnNewDocument())
    return FALSE;

  sgGetScene()->Clear();

  memset(&m_scene_setups,0,sizeof(SCENE_SETUPS));
  m_scene_setups.CurrentColor = 8;

  CMainFrame*  mnFr = static_cast<CMainFrame*>(theApp.m_pMainWnd);
  mnFr->ResetNames();
  mnFr->UpdateSystemToolbar();

  return TRUE;
}

void CSolidgraphDoc::OnCloseDocument()
{
  sgGetScene()->Clear();
  CDocument::OnCloseDocument();
}

BOOL CSolidgraphDoc::OnOpenDocument(LPCTSTR lpszPathName)
{
	sgGetScene()->Clear();

  if (!CDocument::OnOpenDocument(lpszPathName))
    return FALSE;
  
 /*
	Only in register version
	*/
  AfxMessageBox("Only in register version");

  CMainFrame*  mnFr = static_cast<CMainFrame*>(theApp.m_pMainWnd);
  mnFr->ResetNames();
  mnFr->UpdateSystemToolbar();

  return TRUE;
}

BOOL CSolidgraphDoc::OnSaveDocument(LPCTSTR lpszPathName)
{
	/*
	Only in register version
	*/
  AfxMessageBox("Only in register version");

  return TRUE;
}




// CSolidgraphDoc serialization

void CSolidgraphDoc::Serialize(CArchive& ar)
{
  /*if (ar.IsStoring())
  {
	  int aaa = sgGetScene()->GetObjectsList()->GetCount();
	  ar.Write(&aaa,sizeof(int));
	  sgCObject* cO = sgGetScene()->GetObjectsList()->GetHead();
	  while (cO) 
	  {
		  unsigned long sz =  0;
		  const void* bbb  = sgFileManager::ObjectToBitArray(cO,sz);
		  ar.Write(&sz,sizeof(unsigned long));
		  ar.Write(bbb,sz);
		  cO = sgGetScene()->GetObjectsList()->GetNext(cO);
	  }
  }
  else
  {
	  int cnt = 0;
	  unsigned long sz = 0;
	  ar.Read(&cnt,sizeof(int));

	  for (int i=0;i<cnt;i++)
	  {	
		  ar.Read(&sz,sizeof(unsigned long));
		  char* bbb  = new char[sz];
		  memset(bbb,0,sz);
		  ar.Read(bbb,sz);
		  sgGetScene()->AttachObject(sgFileManager::BitArrayToObject(bbb,sz));
		  delete [] bbb;
	  }
  }*/
}


// CSolidgraphDoc diagnostics

#ifdef _DEBUG
void CSolidgraphDoc::AssertValid() const
{
  CDocument::AssertValid();
}

void CSolidgraphDoc::Dump(CDumpContext& dc) const
{
  CDocument::Dump(dc);
}
#endif //_DEBUG


// CSolidgraphDoc commands

void CSolidgraphDoc::OnDxfExport()
{
  /*
	Only in register version
	*/
  AfxMessageBox("Only in register version");
}

void CSolidgraphDoc::OnDxfImport()
{
 /*
	Only in register version
	*/
  AfxMessageBox("Only in register version");
}

void CSolidgraphDoc::OnSTLExport()
{
	/*
	Only in register version
	*/
  AfxMessageBox("Only in register version");
}

void CSolidgraphDoc::OnSTLImport()
{
	/*
	Only in register version
	*/
  AfxMessageBox("Only in register version");
}
